Summary: The PostgreSQL server programs.
Name: postgresql
Version: 6.4.2
Release: 3
Copyright: BSD
Group: Applications/Databases
Source0: ftp://ftp.postgresql.org/pub/postgresql-%{version}.tar.gz
Source2: postgresql.init
Source3: pgsql-Database-HOWTO-html.tar.gz
Patch0: ftp://ftp.postgresql.org/pub/patches/v6.4.2-feature-patch.diff
Buildroot: /var/tmp/pgsql-root
Prereq: /sbin/chkconfig /sbin/ldconfig /usr/sbin/useradd
Url: http://www.postgresql.org/
Requires: postgresql-clients
ExcludeArch: alpha armv4l

%description
Postgresql includes the programs needed to create and run a PostgreSQL
server, which will in turn allow you to create and maintain PostgreSQL
databases.  PostgreSQL is an advanced Object-Relational database
management system (DBMS) that supports almost all SQL constructs
(including transactions, subselects and user-defined types and
functions).

You should install postgresql if you want to create and maintain your
own PostgreSQL databases and/or your own PostgreSQL server.  If you
are installing postgresql, you should also install postgresql-data,
which will help you get started with PostgreSQL.

%package devel
Requires: postgresql-clients
Summary: PostgreSQL development header files and libraries.
Group: Development/Libraries

%description devel
This package contains the header files and libraries needed to
compile applications which will directly interact with a PostgreSQL
server.

Install this package if you want to develop applications which will
interact with a PostgreSQL server.

%package clients
Summary: The client programs needed for accessing a PostgreSQL server.
Group: Applications/Databases

%description clients
Postgresql-clients includes the client programs and client libraries
that you'll need to access a PostgreSQL database management system
server.  This package contains the client libraries for C, C++ and PERL,
as well as command-line utilities for managing PostgreSQL databases on a
remote server. If you just want to connect to an existing remote
PostgreSQL server, this package is all you need.

You should install postgresql-clients if you're installing postgresql.
You should also install postgresql-clients if you're not installing
postgresql, but you want to access PostgreSQL databases on a remote
PostgreSQL server.

%prep
%setup -q
%patch0 -p0

%build
cd src
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr \
	--enable-hba --enable-locale \
	--with-tcl --with-perl --with-x
make
cd ..
make all PGDOCS=unpacked -C doc

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/{include/pgsql,lib,bin}
make POSTGRESDIR=$RPM_BUILD_ROOT/usr PREFIX=$RPM_BUILD_ROOT/usr install -C src
make POSTGRESDIR=$RPM_BUILD_ROOT/usr PREFIX=$RPM_BUILD_ROOT/usr install -C src/man
find $RPM_BUILD_ROOT/usr/lib/perl5 -name .packlist -exec rm -f {} \;
find $RPM_BUILD_ROOT/usr/lib/perl5 -type f -print | \
	sed -e "s|$RPM_BUILD_ROOT/|/|g" > perlfiles.list
find $RPM_BUILD_ROOT/usr/lib/perl5 -type d -name Pg -print | \
	sed -e "s|$RPM_BUILD_ROOT/|%dir /|g" >> perlfiles.list
make -C doc
# Move all includes beneath /usr/include/pgsql.
pushd $RPM_BUILD_ROOT/usr/include
rm -rf include
for f in *.h access commands executor lib libpq libpq++ port utils ; do
    mv $f pgsql
done
popd
# Move all templates/examples beneath /usr/lib/pgsql
pushd $RPM_BUILD_ROOT/usr/lib
mkdir -p pgsql
mv *source *sample pgsql
popd

install -m 0755 src/bin/pgaccess/pgaccess.tcl $RPM_BUILD_ROOT/usr/bin/pgaccess

chmod 644 $RPM_BUILD_ROOT/usr/man/*/*
install -d $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 $RPM_SOURCE_DIR/postgresql.init $RPM_BUILD_ROOT/etc/rc.d/init.d/postgresql

## Create sample database
mkdir -p $RPM_BUILD_ROOT/var/lib/pgsql
#PATH=/usr/sbin:$PATH useradd -M -r -d /var/lib/pgsql -s /bin/bash \
#	-c "PostgreSQL Server" postgres || :
#chown -R postgres.postgres $RPM_BUILD_ROOT/var/lib/pgsql
#export PATH=$PATH:$RPM_BUILD_ROOT/usr/bin
#[ ! -f $RPM_BUILD_ROOT/usr/lib/libpq.so.1 ] && ln -sf libpq.so $RPM_BUILD_ROOT/usr/lib/libpq.so.1
#unset ENV || :
#su postgres -c "LD_LIBRARY_PATH=$RPM_BUILD_ROOT/usr/lib \
#  $RPM_BUILD_ROOT/usr/bin/initdb --pgdata=$RPM_BUILD_ROOT/var/lib/pgsql \
#		--pglib=$RPM_BUILD_ROOT/usr/lib/pgsql"
#[ -L $RPM_BUILD_ROOT/usr/lib/libpq.so.1 ] && rm -f $RPM_BUILD_ROOT/usr/lib/libpq.so.1
## this was a good one
#chmod 640 $RPM_BUILD_ROOT/var/lib/pgsql/pg_pwd
mkdir -p howto
tar xzf $RPM_SOURCE_DIR/pgsql-Database-HOWTO-html.tar.gz -C howto
mkdir -p pgaccess
cp src/bin/pgaccess/*.html pgaccess
cp src/bin/pgaccess/*.sql pgaccess

# Strip 'em all
strip $RPM_BUILD_ROOT/usr/bin/* || :

%pre
useradd -M -o -r -d /var/lib/pgsql -s /bin/bash \
	-c "PostgreSQL Server" postgres >/dev/null 2>&1 || :

%post -p /sbin/ldconfig

%post -p /sbin/ldconfig clients

%postun -p /sbin/ldconfig clients

%preun
if [ $1 = 0 ] ; then
	chkconfig --del postgresql
fi

%postun
/sbin/ldconfig
if [ $1 = 0 ] ; then
	userdel postgres >/dev/null 2>&1 || : 
fi

%clean
rm -rf $RPM_BUILD_ROOT
rm -f perlfiles.list
rm -rf howto

%files
%defattr(-,root,root)
%config /etc/rc.d/init.d/*
%doc contrib doc/unpacked/* 
%doc doc/FAQ doc/FAQ_Linux doc/README* 
%doc COPYRIGHT README HISTORY src/bin/pgaccess/README.pga doc/bug.template
%doc doc/*.ps.gz
%doc howto
%doc pgaccess
/usr/lib/pgsql
/usr/man/man5/*
/usr/bin/cleardbdir
/usr/bin/createdb
/usr/bin/createuser
/usr/bin/destroydb
/usr/bin/destroyuser
/usr/bin/initdb
/usr/bin/initlocation
/usr/bin/pg_passwd
/usr/bin/pg_version
/usr/bin/postgres
/usr/bin/postmaster
/usr/man/man1/cleardbdir.1
/usr/man/man1/createdb.1
/usr/man/man1/createuser.1
/usr/man/man1/destroydb.1
/usr/man/man1/destroyuser.1
/usr/man/man1/initdb.1
/usr/man/man1/initlocation.1
/usr/man/man1/ipcclean.1
/usr/man/man1/pg_passwd.1
/usr/man/man1/postgres.1
/usr/man/man1/postmaster.1
%attr(-,postgres,postgres) %dir /var/lib/pgsql

%files devel
%defattr(-,root,root)
/usr/lib/*.a
/usr/lib/*.so
/usr/include/pgsql
/usr/man/man3/*
/usr/bin/ecpg
/usr/man/man1/ecpg.1

%files -f perlfiles.list clients
%defattr(-,root,root)
%attr(755,root,root) /usr/lib/libpq.so.2.0
%attr(755,root,root) /usr/lib/libecpg.so.2.6.2
%attr(755,root,root) /usr/lib/libpq++.so.2.0
%attr(755,root,root) /usr/lib/libpgtcl.so.2.0
/usr/man/manl/*
/usr/bin/pg_dump
/usr/bin/pg_dumpall
/usr/bin/pg_id
/usr/bin/pgaccess
/usr/bin/pgtclsh
/usr/bin/pgtksh
/usr/bin/psql
/usr/man/man1/pg_dump.1
/usr/man/man1/pg_dumpall.1
/usr/man/man1/psql.1

%changelog
* Sat Apr 17 1999 Jeff Johnson <jbj@redhat.com>
- exclude alpha for Red Hat 6.0.

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 2)

* Wed Feb 03 1999 Cristian Gafton <gafton@redhat.com>
- version 6.4.2
- get rid of the -data package (shipping it was a BAD idea)

* Sat Oct 10 1998 Cristian Gafton <gafton@redhat.com>
- strip all binaries
- use defattr in all packages
- updated pgaccess to version 0.90
- /var/lib/pgsql/pg_pwd should not be 666

* Sun Jun 21 1998 Jeff Johnson <jbj@redhat.com>
- create /usr/lib/pgsql (like /usr/include/pgsql)
- resurrect libpq++.so*
- fix name problem in startup-script (problem #533)

* Fri Jun 19 1998 Jeff Johnson <jbj@redhat.com>
- configure had "--prefix=$RPM_BUILD_ROOT/usr"
- move all include files below /usr/include/pgsql.
- resurrect perl client file lists.

* Tue May 05 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Tue May 05 1998 Cristian Gafton <gafton@redhat.com>
- build on alpha

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- enhanced initscript

* Tue Apr 21 1998 Cristian Gafton <gafton@redhat.com>
- finally v6.3.2 is here !

* Wed Apr 15 1998 Cristian Gafton <gafton@redhat.com>
- added the include files in the devel package

* Wed Apr 01 1998 Cristian Gafton <gafton@redhat.com>
- finally managed to get a patch for 6.3.1 to make it install corectly. Boy,
  what a mess ! ;-(

* Tue Mar 03 1998 Cristian Gafton <gafton@redhat.com>
- upgraded tp 6.3 release

* Sat Feb 28 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to the latest snapshot
- splitted yet one more subpackage: clients

* Tue Jan 20 1998 Cristian Gafton <gafton@redhat.com>
- the installed devel-library is no longer stripped (duh!)
- added the 7 patches found on the ftp.postgresql.org site
- corrected the -rh patch to patch configure.in rather than configure; we
  now use autoconf
- added a patch to fix the broken psort function
- build TCL and C++ libraries as well
- updated pgaccess to version 0.76

* Thu Oct 23 1997 Cristian Gafton <gafton@redhat.com>
- cleaned up the spec file for version 6.2.1
- splited devel subpackage
- added chkconfig support in %preun and %post
- added optional data package

* Mon Oct 13 1997 Elliot Lee <sopwith@cuc.edu> 6.2-3
- Fixed lots of bung-ups in the spec file, made it FSSTND compliant, etc.
- Removed jdbc package, jdk isn't stable yet as far as what goes where.
- Updated to v 6.2.1

* Thu Oct  9 1997 10:58:14 dan
- on pre-installation script now the `data' dir is renamed to
  `data.rpmorig' (no more wild deletions!).
- added `postgresql-jdbc' sub-package.
- postgresql.sh script: defined function `add_to_path()' and
  changed the location of postgresql.jar in the CLASSPATH.

* Sat Oct  4 1997 10:27:43 dan
- updated to version 6.2.
- added auto installation's scripts (pre, post, preun, postun)
